import 'package:string_converter/src/helper.dart';

/// binary
String binary(String text, bool remove) {
  try {
    /// utf8 to bytes
    var bytes = utf8ToBytes(text);

    String ret = "";

    /// list for loop
    for (var i = 0; i < bytes.length; i++) {
      var hexUnit;
      var byte = bytes[i];
      hexUnit = int.parse(byte.toString()).toRadixString(2);

      /// add 0
      while (hexUnit.length < 8) {
        hexUnit = "0" + hexUnit;
      }

      /// check remove 0x
      hexUnit = remove ? hexUnit : "0x" + hexUnit;
      ret += hexUnit;

      /// check last index and remove
      if ((i != bytes.length - 1) && remove) {
        ret += " ";
      }
    }

    /// return text
    return ret;
  } catch (_) {
    return null;
  }
}
